var Figure = Base.extend({
	init: function(x, y, level) {
		this.view = $(DIV).addClass(CLS_FIGURE).appendTo(level.world);
		this.dx = 0;
		this.dy = 0;
		this.dead = false;                  //FLAG PER CAPIRE SE L'OGG è ANCORA VIVO O è MORTO
		this.onground = true;              
		this.setState(size_states.small);   //CHIAMA QUESTA SETSTATESMALL 1 BIG 2
		this.setVelocity(0, 0);             //SETTA LA VELOCITA' DELL'OGGETTO
		this.direction = directions.none;   //NONE 0
		this.level = level;                 //AGGANGIA IL LIVELLO
		this._super(x, y);                  //CHIAMA INIT DELLA CLASS BASE
		level.figures.push(this);           //AGGIUNGE L'OGG ALL'ARRAY DELLE FIGURE
	},
	setState: function(state) {             //
		this.state = state;                 //ASSEGNA A STATE IL VALORE 1 O 2
	},
	setImage: function(img, x, y) {          //FUNZIONE CHE IMPOSTA L'IMG DELL'OGG 
		this.view.css({
			backgroundImage : img ? c2u(img) : 'none',                         //IMPOSTA IL PERCORSO DELL'IMMAGINE
			backgroundPosition : '-' + (x || 0) + 'px -' + (y || 0) + 'px',    //IMPOSTA LA POSIZIONE X Y DELL'OGGETTO NEL FILE HTML A RUN TIME
		});
		this._super(img, x, y);                                                 //CHIAMA SETIMAGE DELLA CLASS BASE
	},
	setOffset: function(dx, dy) {                                    //FUNZIONE SCONOSCIUTA
		this.dx = dx;                                                
		this.dy = dy;
		this.setPosition(this.x, this.y);                           //CHIAMA QUESTA SET POSITION CON I VALORI X Y DELL'OGG
	},
	setPosition: function(x, y) {                                   //IMPOSTA LA POSIZIONE DELL'OGG NEL FILE HTML
		this.view.css({
			left: x,
			bottom: y,
			marginLeft: this.dx,
			marginBottom: this.dy,
		});
		this._super(x, y);                                           //CHIAMA SETPOSITION DELLA CLASSE BASE
		this.setGridPosition(x, y);                                  //CHIAMA QUESTA SETGRIDPOSITION 
	},
	setSize: function(width, height) {                               //SETTA LA DIMENZIONE IN PIXEL DELL'OGG
		this.view.css({
			width: width,
			height: height
		});
		this._super(width, height);                                  //CHIAMA SETSIZE DELLA CLASS BASE
	},
	setGridPosition: function(x, y) {                                //IMPOSTA LA POSIZIONE DELL'OGG NELLA GRIGLIA
		this.i = Math.floor((x + 16) / 32);
		this.j = Math.ceil(this.level.getGridHeight() - 1 - y / 32);
		
		if(this.j > this.level.getGridHeight())
			this.die();
	},
	getGridPosition: function(x, y) {                                 //RITORNA LE COORDINATE I J DELL'OGG NELLA GRIGLIA DEL LIVELLO
		return { i : this.i, j : this.j };
	},
	setVelocity: function(vx, vy) {                                   //IMPOSTA LA VELOCITà DELL'OGG
		this.vx = vx;                                                 //VELOCITà ORIZZONTALE
		this.vy = vy;                                                 //VELOCITà VERTICALE
		
		if(vx > 0)                                                    //SE VX è UN NUMERO POSITIVO VA A DESTRA
			this.direction = directions.right;    // RIGHT 3
		else if(vx < 0)                                               //SE VX è UN NUMERO NEGATIVO VA A SINISTRA
			this.direction = directions.left;     //LEFT 1
	},
	getVelocity: function() {                                         //RITORNA LA VELOCITà DELL'OGG
		return { vx : this.vx, vy : this.vy };
	},
	hit: function(opponent) {                                         //FUNZIONE CHE GESTISCE SE L'OGG VIENE COLPITO...ATTUALMENTE VUOTA
		
	},
	collides: function(is, ie, js, je, blocking) {                    //FUNZIONE CHE GESTISCE LA COLLISIONE DELL'OGG CON UN ALTRO
		var isHero = this instanceof Hero;                            //SE IL CHIAMANTE è HERO TRUE ALTRIMENTI è FALSE
		
		if(is < 0 || ie >= this.level.obstacles.length)               
			return true;
			
		if(js < 0 || je >= this.level.getGridHeight())
			return false;
			
		for(var i = is; i <= ie; i++) {
			for(var j = je; j >= js; j--) {
				var obj = this.level.obstacles[i][j];
				
				if(obj) {
					if(obj instanceof Item && isHero && (blocking === ground_blocking.bottom || obj.blocking === ground_blocking.none))
						obj.activate(this);
					
					if((obj.blocking & blocking) === blocking)
						return true;
				}
			}
		}
		
		return false;
	},
	move: function() {                                                //FUNZIONE CHE GESTISCE IL MOVIMENTO DELL'OGG
		var vx = this.vx;                             //VELOCITà ORIZZONTALE
		var vy = this.vy - constants.gravity;         //VELOCITà VERTICALE
		
		var s = this.state;                           //STATO DELL'OGG (BIG O SMALL)
		
		var x = this.x;                               //POSIZIONE X DELL'OGG
		var y = this.y;                               //POSIZIOE Y DELL'OGG
		                                              //GESTIONE OFFSET
		var dx = Math.sign(vx);                       //SE IL VALORE PASSATO è POSITIVO ALLORE 1 ALTRIMENTI -1// VIENE PASSATA LA VELOCITà ORIZZONTALE
		var dy = Math.sign(vy);                       //SE IL VALORE PASSATO è POSITIVO ALLORE 1 ALTRIMENTI -1// VIENE PASSATA LA VELOCITà VERTICALE
		
		var is = this.i;
		var ie = is;
		
		var js = Math.ceil(this.level.getGridHeight() - s - (y + 31) / 32);
		var je = this.j;
		
		var d = 0, b = ground_blocking.none;
		var onground = false;
		var t = Math.floor((x + 16 + vx) / 32);
		
		if(dx > 0) {
			d = t - ie;
			t = ie;
			b = ground_blocking.left;
		} else if(dx < 0) {
			d = is - t;
			t = is;
			b = ground_blocking.right;
		}
		
		x += vx;
		
		for(var i = 0; i < d; i++) {
			if(this.collides(t + dx, t + dx, js, je, b)) {
				vx = 0;
				x = t * 32 + 15 * dx;
				break;
			}
			
			t += dx;
			is += dx;
			ie += dx;
		}
		
		if(dy > 0) {
			t = Math.ceil(this.level.getGridHeight() - s - (y + 31 + vy) / 32);
			d = js - t;
			t = js;
			b = ground_blocking.bottom;
		} else if(dy < 0) {
			t = Math.ceil(this.level.getGridHeight() - 1 - (y + vy) / 32);
			d = t - je;
			t = je;
			b = ground_blocking.top;
		} else
			d = 0;
		
		y += vy;
		
		for(var i = 0; i < d; i++) {
			if(this.collides(is, ie, t - dy, t - dy, b)) {
				onground = dy < 0;
				vy = 0;
				y = this.level.height - (t + 1) * 32 - (dy > 0 ? (s - 1) * 32 : 0);
				break;
			}
			
			t -= dy;
		}
		
		this.onground = onground;
		this.setVelocity(vx, vy);
		this.setPosition(x, y);
	},
	death: function() {                                               //FUNZIONE GESTIONE MORTE DELL'OGG
		return false;                                                 //RITORNA SEMPRE FALSE
	},
	die: function() {                                                 //FUNZIONE GESTIONE MORTE DELL'OGG
		this.dead = true;                                             //IMPOSTA IL FLAG A TRUE// L'OGG è MORTO
	},
});
