/*
 * -------------------------------------------
 * ENEMY CLASS
 * -------------------------------------------
 */
var Enemy = Figure.extend({                             //CLASSE PER LA GESTIONE DEI NEMICI FIGLIA DI FIGURE
	init: function(x, y, level) {
		this._super(x, y, level);                       //CHIAMA INIT DELLA CLASS FIGURE
		this.speed = 0;                                 //VARIABILE VELOCITà
	},
	hide: function() {                                  //FUNZIONE CHE NASCONDE IL NEMICO
		this.invisible = true;                          //IMPOSTA IL FLAG DI INVISIBILITà A TRUE
		this.view.hide();                               //NASCONDE IL NEMICO NEL FILE HTML A RUN TIME
	},
	show: function() {	                                //FUNZIONE CHE MOSTRA IL NEMICO
		this.invisible = false;                         //IMPOSTA IL FLAG DI INVISIBILITà A FALSE
		this.view.show();                               //MOSTRA IL NEMICO NEL FILE HTML A RUN TIME
	},
	move: function() {                                  //GESTISCE IL MOVIMENTO DEL NEMICO
		if(!this.invisible) {                           //SE IL NEMICO è VISIBILE
			this._super();                              //CHIAMA MOVE DELLA CLASS FIGURE
		
			if(this.vx === 0) {                         //SE LA VELOCITà ORIZZONTALE DEL NEMICO è ZERO
				var s = this.speed * Math.sign(this.speed);   //DETERMINA LA DIREZIONE DESTRA 1 SINISTRA -1 FERMO 0
				this.setVelocity(this.direction === directions.right ? -s : s, this.vy); //CHIAMA SETVELOCITY DELLA CLASS FIGURE
			}
		}
	},
	collides: function(is, ie, js, je, blocking) {
		if(this.j + 1 < this.level.getGridHeight()) {
			for(var i = is; i <= ie; i++) {
				if(i < 0 || i >= this.level.getGridWidth())
					return true;
					
				var obj = this.level.obstacles[i][this.j + 1];
				
				if(!obj || (obj.blocking & ground_blocking.top) !== ground_blocking.top)
					return true;
			}
		}
		
		return this._super(is, ie, js, je, blocking);
	},
	setSpeed: function(v) {                              //IMPOSTA LA VELOCITà DEL NEMICO...VUOLE LA VARIABILE DELLA VELOCITà ATTUALE
		this.speed = v;                                  //ASSEGNA LA VELOCITà CORRENTE
		this.setVelocity(-v, 0);                         //CHAIMA SETVELOCITI DELLA CLASS FIGURE
	},
	hurt: function(from) {                               //GESTIONE MORTE DEL NEMICO
		this.die();                                      //CHIAMA DIE DELLA CLASSE FIGURE
	}, 
	hit: function(opponent) {                            //GESTIONE NEMICO COLPITO //RICHIEDE OPPONENT
		if(this.invisible)                               //SE IL NEMICO è INVISIBILE
			return;                                      //NON ACCADE NULLA
			
		if(opponent instanceof Mario) {                  //SE L'OPPONENT è MARIO
			if(opponent.vy < 0 && opponent.y - opponent.vy >= this.y + this.state * 32) {           
				opponent.setVelocity(opponent.vx, constants.bounce);
				this.hurt(opponent);
			} else {
				opponent.hurt(this);
			}
		}
	},
});
