﻿/*
 * -------------------------------------------
 * BASE CLASS
 * -------------------------------------------
 */

//console.log('CLASS BASE');
console.log('sono BASE');
var Base = Class.extend({
	init: function(x, y) {							//COSTRUTTORE INPUT COORDINATE X Y (CHIAMATA SOLO UNA VOLTA) SE è SENZA PARM X = Y = 0
		this.setPosition(x || 0, y || 0);           //IMPOSTA LE POSIZIONI DI OGNI OGGETTO DERIVATO NELLA FINESTRA
		this.clearFrames();                         //RE-INIZIALIZZA I FRAMES
		this.frameCount = 0;                        //SETTA IL NUMERO DI FRAME A ZERO
	},
	setPosition: function(x, y) {                   //FUNZIONE CHE IMPOSTA LE COORDINATE DELL'OGG
		this.x = x;
		this.y = y;
	},
	getPosition: function() {                       //FUNZIONE PER RECUPERARE LE COORDINATE DELL'OGG
		return { x : this.x, y : this.y };
	},
	setImage: function(img, x, y) {                 //FUNZIONE CHE IMPOSTA L'IMG NELLE COORDINATE SPECIFICATE X Y
		this.image = {                              //COSTRUISCE UNA STRUTTURA image con {path ,x,y}
			path : img,
			x : x,
			y : y
		};
	},
	setSize: function(width, height) {              //FUNZIONE CHE IMPOSTA ALTEZZA E LARGHEZZA DELL'OGG
		this.width = width;
		this.height = height;
	},
	getSize: function() {                           //FUNZIONE CHE RITORNA ALTEZZA E LARGHEZZA DELL'OGG
		return { width: this.width, height: this.height };
	},
	setupFrames: function(fps, frames, rewind, id) { // FUNZIONE CHE IMPOSTA I FRAMES DELL'OGG SPECIFICANDO (FPS, FRAMES, REWIND, ID)
		if(id) {
			if(this.frameID === id)
				return true;
			
			this.frameID = id;
		}
		
		this.currentFrame = 0;
		this.frameTick = frames ? (1000 / fps / constants.interval) : 0;
		this.frames = frames;
		this.rewindFrames = rewind;
		return false;
	},
	clearFrames: function() {                        //FUNZIONE CHE RESETTA I FRAMES DI UN OGGETTO SULLO SCHERMO
		this.frameID = undefined;
		this.frames = 0;
		this.currentFrame = 0;
		this.frameTick = 0;
	},
	playFrame: function() {
		if(this.frameTick && this.view) {
			this.frameCount++;
			
			if(this.frameCount >= this.frameTick) {			
				this.frameCount = 0;
				
				if(this.currentFrame === this.frames)
					this.currentFrame = 0;
					
				var $el = this.view;
				$el.css('background-position', '-' + (this.image.x + this.width * ((this.rewindFrames ? this.frames - 1 : 0) - this.currentFrame)) + 'px -' + this.image.y + 'px');
				this.currentFrame++;
			}
		}
	},
});

/*
 * -------------------------------------------
 * GAUGE CLASS
 * -------------------------------------------
 */
 //console.log(Base);
 //console.log('CLASS GAUGE');
var Gauge = Base.extend({
	init: function(id, startImgX, startImgY, fps, frames, rewind) {
		this._super(0, 0);
		this.view = $('#' + id);
		this.setSize(this.view.width(), this.view.height());
		this.setImage(this.view.css('background-image'), startImgX, startImgY);
		this.setupFrames(fps, frames, rewind);
	},
});
 //console.log(Gauge);

/*
 * -------------------------------------------
 * LEVEL CLASS
 * -------------------------------------------
 */
var Level = Base.extend({
	init: function(id) {                                      //FUNZIONE COSTRUTTORE PARAM L'ID DEL LIVELLO
		this.world = $('#' + id);                             //JQUERY IMPOSTA 
		this.nextCycles = 0;                                  //VARIABILE SCONOSCIUTA
		this._super(0, 0);                                    //RICHIAMO COSTRUTTORE CLASSE BASE COORDINATE  X = 0 Y = 0
		this.active = false;                                  //FLAG ACTIVE A FALSE
		this.figures = [];                                    //ARRAY FIGURES INIZIALIZZATO
		this.obstacles = [];                                  //ARRAY DECO...
		this.decorations = [];                                //...
		this.items = [];                                      // IDEM FINO A QUI
		this.clickItems = [];                                 //MIA STRUTTURA PER TENERE TRACCIA DEGLI OGGETTI CLICCABILI
		this.coinGauge = new Gauge('coin', 0, 0, 10, 4, true);  //CONTATORE A SCHERMO DELLE MONETINE
		this.liveGauge = new Gauge('live', 0, 430, 6, 6, true);  //CONTATORE A SCHERMO DELLE VITE
	},
	reload: function() {
		var settings = {};
		this.pause();
		
		for(var i = this.figures.length; i--; ) {
			if(this.figures[i] instanceof Mario) {
				settings.lifes = this.figures[i].lifes - 1;
				settings.coins = this.figures[i].coins;
				break;
			}
		}
		
		this.reset();
		
		if(settings.lifes < 0) {
			this.load(definedLevels[0]);
		} else {		
			this.load(this.raw);
			
			for(var i = this.figures.length; i--; ) {
				if(this.figures[i] instanceof Mario) {
					this.figures[i].setLifes(settings.lifes || 0);
					this.figures[i].setCoins(settings.coins || 0);
					break;
				}
			}
		}
		
		this.start();
	},
	load: function(level) {                                   //FUNZIONE CHE CARICA IL LIVELLO...PARAM ARRAY CONTENENTE I VARI LIVELLI
		if(this.active) {                                     //CONTROLLA IL FLAG ACTIVE SICCOME DI DEFAULT è FALSE SALTA L'IF
			if(this.loop)
				this.pause();
			this.reset();
		}
	    
		this.setPosition(0, 0);                            //RICHIAMA LA FUNZIONE SETPOSITION
		this.setSize(level.width * 32, level.height * 32); //RICHIAMA LA FUNZIONE PER IMPOSTARE LA DIMENZIONE DEL LIVELLO
		this.setImage(level.background);                   //RICHIAMA LA FUNZIONE PER IMPOSTARE L'IMG CON PARAMETRO IL BACKGROUD TESTSLEVELS
		this.raw = level;                                  
		this.id = level.id;                                //ID LEVELS TESTLEVELS
		this.active = true;                                //CAMBIA IL FLAG ACTIVE A TRUE
		var data = level.data;                             //COPIA ARRAY DATA DEL LIVELLO TESTSLEVELS
		
		for(var i = 0; i < level.width; i++) {             //PER OGNI RIGA DEL LIVELLO
			var t = [];                                    
			
			for(var j = 0; j < level.height; j++) {        //PER OGNI COLONNA DEL LIVELLO
				t.push('');                                //SETTA IL VALORE DI OGNI ELEMENTO A NULL ""
			}
			
			this.obstacles.push(t);                        //COPIA LA RIGA NULLA NELLE VARIE POSIZIONI DELL'ARRAY OBSTACLES
		}
		
		//console.log('array obstacles ' + this.obstacles.length);
		for(var i = 0, width = data.length; i < width; i++) {            // FOR I < 180  PER OGNI RIGA DELL'ARRAY (RIGA TESTSLEVELS)
			var col = data[i];                                           // COPIA ELEMENTO DATA[I] PER RIGHE
		    //var count = 0;
			for(var j = 0, height = col.length; j < height; j++) {       //FOR J < 15   PER OGNI COLONNA DELL'ARRAY
				if(reflection[col[j]]) {                                 //
					
					//count++;
					new (reflection[col[j]])(i * 32, (height - j - 1) * 32, this);   //INIZIALIZZA CIASCUN ELEMENTO DEL LIVELLO CHIAMANDO GLI INIT APPROPRIATI
			        //console.log('x : ' + (i*32) + ' y : ' + ((height - j - 1) * 32));//LE X E Y DIPENDONO DAI CALCOLI CONSIDERANDO I E J
				}
			} 
			//console.log(count);
		}
		
	},
	next: function() {
		this.nextCycles = Math.floor(1500 / constants.interval);
	},
	nextLoad: function() {
		if(this.nextCycles)
			return;
		
		var settings = {};
		this.pause();
		
		for(var i = this.figures.length; i--; ) {
			if(this.figures[i] instanceof Mario) {
				settings.lifes = this.figures[i].lifes;
				settings.coins = this.figures[i].coins;
				settings.state = this.figures[i].state;
				settings.marioState = this.figures[i].marioState;
				break;
			}
		}
		
		this.reset();
		this.load(definedLevels[this.id + 1]);
		
		for(var i = this.figures.length; i--; ) {
			if(this.figures[i] instanceof Mario) {
				this.figures[i].setLifes(settings.lifes || 0);
				this.figures[i].setCoins(settings.coins || 0);
				this.figures[i].setState(settings.state || size_states.small);
				this.figures[i].setMarioState(settings.marioState || mario_states.normal);
				break;
			}
		}
		
		this.start();
	},
	getGridWidth: function() {
		return this.raw.width;
	},
	getGridHeight: function() {
		return this.raw.height;
	},
	setSounds: function(manager) {
		this.sounds = manager;
	},
	playSound: function(label) {
		if(this.sounds)
			this.sounds.play(label);
	},
	playMusic: function(label) {
		if(this.sounds)
			this.sounds.sideMusic(label);
	},
	reset: function() {
		this.active = false;
		this.world.empty();
		this.figures = [];
		this.obstacles = [];
		this.items = [];
		this.decorations = [];
	},
	tick: function() {
		if(this.nextCycles) {
			this.nextCycles--;
			this.nextLoad();			
			return;
		}
		var i = 0, j = 0, figure, opponent;
		
		for(i = this.figures.length; i--; ) {                   //PER TUTTA LA LUNGHEZZA DELL'ARRAY DELLE FIGURE
			figure = this.figures[i];                           //ESTRAGGO IL RIFERIMENTO ALLA FIGURA 
			if(figure.dead) {                                
				if(!figure.death()) {                           //SE LA FIGURA MUORE
					if(figure instanceof Mario)                    //ED è MARIO ALLORA
						return this.reload();					     //GAME OVER RELOAD THE GAME
						
					figure.view.remove();
					this.figures.splice(i, 1);
				} else
					figure.playFrame();                        //SE LA FIGURA è VIVA ESEGUI I FRAME DELLA STESSA
			} else {
				if(i) {
					for(j = i; j--; ) {
						if(figure.dead)
							break;
							
						opponent = this.figures[j];
						
						if(!opponent.dead && q2q(figure, opponent)) {
							figure.hit(opponent);
							opponent.hit(figure);
						}
					}
				}
			}
			
			if(!figure.dead) {                                 //SE LA FIGURA NON è MORTA
				figure.move();                                 //CHIAMA MOVE DELLA FIGURA
				figure.playFrame();                            //ESEGUI PLAYFRAME DELLA FIGURA (ALIAS ANIMAZIONE)
			
			}
		}
		

		
		
		for(i = this.items.length; i--; )                      //PER OGNI OGGETTO
			this.items[i].playFrame();                         //ESEGUE L'ANIMAZIONE
					
		
		this.coinGauge.playFrame();                            //ESEGUE L'ANIMAZIONE DELLO SPRITE DEI COINS TOTALI
		this.liveGauge.playFrame();                            //ESEGUE L'ANIMAZIONE DELLO SPRITE DELLE VITE
	},
	start: function() {
		var me = this;                  
		me.loop = setInterval(function() {                           //SETINTERVAL PERMETTE DI CHIAMARE UNA FUNZIONE CON UN INTERVALLO DI TEMPO
                                                                     //LA CHIAMATA VIENE ESEGUITA FINO A QUANDO NON VIENE CHIAMATO CLEAR INTERVAL (LOOP INFINITO)
			me.tick.apply(me);                                       //APPLY PERMETTE DI ESEGUIRE UNA FUNZIONE PASSANDO COME PARAMETRO THIS
		}, constants.interval);
	},
	pause: function() {
		clearInterval(this.loop);
		this.loop = undefined;
	},
	setPosition: function(x, y) {                                //IMPOSTA LA POSIZIONE DELL'OGG
		this._super(x, y);                                       //CHIAMA IL METODO SET POSITION PADRE
		this.world.css('left', -x);                              
	},
	setImage: function(index) {                                                           
		var img = BASEPATH + 'backgrounds/' + ((index < 10 ? '0' : '') + index) + '.gif'; // PERCORSO DEL BACKGROUND SU DISCO
		this.world.parent().css({
			backgroundImage : c2u(img),
			backgroundPosition : '0 -380px'
		});
		this._super(img, 0, 0);
	},
	setSize: function(width, height) {                            //IMPOSTA LA DIMENSIONE DEL LIVELLO
		this._super(width, height);                               //RICHIAMA IL METODO SET SIZE PADRE
	},
	setParallax: function(x) {
		this.setPosition(x, this.y);
		this.world.parent().css('background-position', '-' + Math.floor(x / 1.4) + 'px -380px');
	},
});

/*
 * -------------------------------------------
 * FIGURE CLASS
 * -------------------------------------------
 */
var Figure = Base.extend({
	init: function(x, y, level) {
		this.view = $(DIV).addClass(CLS_FIGURE).appendTo(level.world);
		this.dx = 0;
		this.dy = 0;
		this.dead = false;
		this.onground = true;
		this.setState(size_states.small);
		this.setVelocity(0, 0);
		this.direction = directions.none;
		this.level = level;
		this._super(x, y);
		level.figures.push(this);
	},
	setState: function(state) {
		this.state = state;
	},
	setImage: function(img, x, y) {
		this.view.css({
			backgroundImage : img ? c2u(img) : 'none',
			backgroundPosition : '-' + (x || 0) + 'px -' + (y || 0) + 'px',
		});
		this._super(img, x, y);
	},
	setOffset: function(dx, dy) {
		this.dx = dx;
		this.dy = dy;
		this.setPosition(this.x, this.y);
	},
	setPosition: function(x, y) {
		this.view.css({
			left: x,
			bottom: y,
			marginLeft: this.dx,
			marginBottom: this.dy,
		});
		this._super(x, y);
		this.setGridPosition(x, y);
	},
	setSize: function(width, height) {
		this.view.css({
			width: width,
			height: height
		});
		this._super(width, height);
	},
	setGridPosition: function(x, y) {
		this.i = Math.floor((x + 16) / 32);
		this.j = Math.ceil(this.level.getGridHeight() - 1 - y / 32);
		
		if(this.j > this.level.getGridHeight())
			this.die();
	},
	getGridPosition: function(x, y) {
		return { i : this.i, j : this.j };
	},
	setVelocity: function(vx, vy) {
		this.vx = vx;
		this.vy = vy;
		
		if(vx > 0)
			this.direction = directions.right;
		else if(vx < 0)
			this.direction = directions.left;
	},
	getVelocity: function() {
		return { vx : this.vx, vy : this.vy };
	},
	hit: function(opponent) {
		
	},
	collides: function(is, ie, js, je, blocking) {
		var isHero = this instanceof Hero;
		
		if(is < 0 || ie >= this.level.obstacles.length)
			return true;
			
		if(js < 0 || je >= this.level.getGridHeight())
			return false;
			
		for(var i = is; i <= ie; i++) {
			for(var j = je; j >= js; j--) {
				var obj = this.level.obstacles[i][j];
				
				if(obj) {
					if(obj instanceof Item && isHero && (blocking === ground_blocking.bottom || obj.blocking === ground_blocking.none))
						obj.activate(this);
					
					if((obj.blocking & blocking) === blocking)
						return true;
				}
			}
		}
		
		return false;
	},
	move: function() {
		var vx = this.vx;                             //SPEED  X
		var vy = this.vy - constants.gravity;         //SPEED Y - GRAVITY
		
		var s = this.state;                           //FIGURE STATE
		
		var x = this.x;                               //POSITIONS X Y
		var y = this.y;
		
		var dx = Math.sign(vx);
		var dy = Math.sign(vy);
		
		var is = this.i;
		var ie = is;
		
		var js = Math.ceil(this.level.getGridHeight() - s - (y + 31) / 32);
		var je = this.j;
		
		var d = 0, b = ground_blocking.none;
		var onground = false;
		var t = Math.floor((x + 16 + vx) / 32);
		
		if(dx > 0) {
			d = t - ie;
			t = ie;
			b = ground_blocking.left;
		} else if(dx < 0) {
			d = is - t;
			t = is;
			b = ground_blocking.right;
		}
		
		x += vx;
		
		for(var i = 0; i < d; i++) {
			if(this.collides(t + dx, t + dx, js, je, b)) {
				vx = 0;
				x = t * 32 + 15 * dx;
				break;
			}
			
			t += dx;
			is += dx;
			ie += dx;
		}
		
		if(dy > 0) {
			t = Math.ceil(this.level.getGridHeight() - s - (y + 31 + vy) / 32);
			d = js - t;
			t = js;
			b = ground_blocking.bottom;
		} else if(dy < 0) {
			t = Math.ceil(this.level.getGridHeight() - 1 - (y + vy) / 32);
			d = t - je;
			t = je;
			b = ground_blocking.top;
		} else
			d = 0;
		
		y += vy;
		
		for(var i = 0; i < d; i++) {
			if(this.collides(is, ie, t - dy, t - dy, b)) {
				onground = dy < 0;
				vy = 0;
				y = this.level.height - (t + 1) * 32 - (dy > 0 ? (s - 1) * 32 : 0);
				break;
			}
			
			t -= dy;
		}
		
		this.onground = onground;
		this.setVelocity(vx, vy);
		this.setPosition(x, y);
	},
	death: function() {
		return false;
	},
	die: function() {
		this.dead = true;
	},
});

/*
 * -------------------------------------------
 * MATTER CLASS
 * -------------------------------------------
 */
var Matter = Base.extend({
	init: function(x, y, blocking, level) {
		this.blocking = blocking;
		this.view = $(DIV).addClass(CLS_MATTER).appendTo(level.world);
		this.level = level;
		this._super(x, y);
		this.setSize(32, 32);
		this.addToGrid(level);
		//console.log(this.view);
		
	},
	addToGrid: function(level) {
		level.obstacles[this.x / 32][this.level.getGridHeight() - 1 - this.y / 32] = this;
	},
	setImage: function(img, x, y) {
		this.view.css({
			backgroundImage : img ? c2u(img) : 'none',
			backgroundPosition : '-' + (x || 0) + 'px -' + (y || 0) + 'px',
		});
		this._super(img, x, y);
	},
	setPosition: function(x, y) {
		this.view.css({
			left: x,
			bottom: y
		});
		this._super(x, y);
	},
});

/*
 * -------------------------------------------
 * GROUND CLASS
 * -------------------------------------------
 */
var Ground = Matter.extend({
	init: function(x, y, blocking, level) {
		this._super(x, y, blocking, level);
	},
});

/*
 * -------------------------------------------
 * GRASS CLASSES
 * -------------------------------------------
 */
var TopGrass = Ground.extend({
	init: function(x, y, level) {
		var blocking = ground_blocking.top;
		this._super(x, y, blocking, level);
		this.setImage(images.objects, 888, 404);
	},
}, 'grass_top');
var TopRightGrass = Ground.extend({
	init: function(x, y, level) {
		var blocking = ground_blocking.top + ground_blocking.right;
		this._super(x, y, blocking, level);
		this.setImage(images.objects, 920, 404);
	},
}, 'grass_top_right');
var TopLeftGrass = Ground.extend({
	init: function(x, y, level) {
		var blocking = ground_blocking.left + ground_blocking.top;
		this._super(x, y, blocking, level);
		this.setImage(images.objects, 854, 404);
	},
}, 'grass_top_left');
var RightGrass = Ground.extend({
	init: function(x, y, level) {
		var blocking = ground_blocking.right;
		this._super(x, y, blocking, level);
		this.setImage(images.objects, 920, 438);
	},
}, 'grass_right');
var LeftGrass = Ground.extend({
	init: function(x, y, level) {
		var blocking = ground_blocking.left;
		this._super(x, y, blocking, level);
		this.setImage(images.objects, 854, 438);
	},
}, 'grass_left');
var TopRightRoundedGrass = Ground.extend({
	init: function(x, y, level) {
		var blocking = ground_blocking.top;
		this._super(x, y, blocking, level);
		this.setImage(images.objects, 920, 506);
	},
}, 'grass_top_right_rounded');
var TopLeftRoundedGrass = Ground.extend({
	init: function(x, y, level) {
		var blocking = ground_blocking.top;
		this._super(x, y, blocking, level);
		this.setImage(images.objects, 854, 506);
	},
}, 'grass_top_left_rounded');

/*
 * -------------------------------------------
 * STONE CLASSES
 * -------------------------------------------
 */
var Stone = Ground.extend({
	init: function(x, y, level) {
		var blocking = ground_blocking.all;
		this._super(x, y, blocking, level);
		this.setImage(images.objects, 548, 160);
	},
}, 'stone');
var BrownBlock = Ground.extend({
	init: function(x, y, level) {
		var blocking = ground_blocking.all;
		this._super(x, y, blocking, level);
		this.setImage(images.objects, 512, 194);
	},
}, 'brown_block');

var UpArrow = Ground.extend({
	init: function(x, y, level) {
		var blocking = ground_blocking.all; 
		this._super(x, y, blocking, level);
		this.setImage(images.objects, 953, 404);
	},
}, 'up_arrow'); 
var RightArrow = Ground.extend({
	init: function(x, y, level) {
		var blocking = ground_blocking.all; 
		this._super(x, y, blocking, level);
		this.setImage(images.objects, 987, 404);
	},
}, 'right_arrow'); 
var DownArrow = Ground.extend({
	init: function(x, y, level) {
		var blocking = ground_blocking.all; 
		this._super(x, y, blocking, level);
		this.setImage(images.objects, 987, 439);
	},
}, 'down_arrow');
var LeftArrow = Ground.extend({
	init: function(x, y, level) {
		var blocking = ground_blocking.all; 
		this._super(x, y, blocking, level);
		this.setImage(images.objects, 953, 439);
	},
}, 'left_arrow');
var Ctrl = Ground.extend({
	init: function(x, y, level) {
		var blocking = ground_blocking.all; 
		this._super(x, y, blocking, level);
		this.setImage(images.objects, 1023, 404);
	},
}, 'ctrl');
var Bastone = Ground.extend({
	init: function(x, y, level) {
		var blocking = ground_blocking.none; 
		this._super(x, y, blocking, level);
		this.setImage(images.objects, 614, 393);
	},
}, 'bastone');

/*
 * -------------------------------------------
 * ROAD SIGN CLASS
 * -------------------------------------------
 */
  var Sign = Base.extend({
	init: function(x, y, blocking, level) {
		this.blocking = blocking;
		this.view = $(DIV).addClass(CLS_SIGN).appendTo(level.world);
		this.level = level;
		this._super(x, y);
		this.setSize(160, 96);
		this.addToGrid(level);
		//console.log(this.view);
		
	},
	addToGrid: function(level) {
		level.obstacles[this.x / 32][this.level.getGridHeight() - 1 - this.y / 32] = this;
	},
	setImage: function(img, x, y) {
		this.view.css({
			backgroundImage : img ? c2u(img) : 'none',
			backgroundPosition : '-' + (x || 0) + 'px -' + (y || 0) + 'px',
		});
		this._super(img, x, y);
	},
	setPosition: function(x, y) {
		this.view.css({
			left: x,
			bottom: y
		});
		this._super(x, y);
	},
});

 
/*
 * -------------------------------------------
 * CARTELLO MILAZZO
 * -------------------------------------------
 */
 
var Milazzo = Sign.extend({
	init: function(x, y, level) {
		var blocking = ground_blocking.none; 
		this._super(x, y, blocking, level);
		this.setImage(images.objects, 955, 714);
	},
}, 'milazzo');
/*
 * -------------------------------------------
 * CARTELLO TORONTO
 * -------------------------------------------
 */
var Toronto = Sign.extend({
	init: function(x, y, level) {
		var blocking = ground_blocking.none; 
		this._super(x, y, blocking, level);
		this.setImage(images.objects, 1040, 2);
	},
}, 'toronto');
/*
 * -------------------------------------------
 * CARTELLO Panneau
 * -------------------------------------------
 */

var Panneau = Sign.extend({
	init: function(x, y, level) {
		var blocking = ground_blocking.none; 
		this._super(x, y, blocking, level);
		this.setImage(images.objects, 876, 2);
	},
}, 'panneau');

/*
 * -------------------------------------------
 * PIPE CLASSES
 * -------------------------------------------
 */
var RightTopPipe = Ground.extend({
	init: function(x, y, level) {
		var blocking = ground_blocking.all;
		this._super(x, y, blocking, level);
		this.setImage(images.objects, 36, 358);
	},
}, 'pipe_top_right');
var LeftTopPipe = Ground.extend({
	init: function(x, y, level) {
		var blocking = ground_blocking.all;
		this._super(x, y, blocking, level);
		this.setImage(images.objects, 2, 358);
	},
}, 'pipe_top_left');
var RightPipe = Ground.extend({
	init: function(x, y, level) {
		var blocking = ground_blocking.right + ground_blocking.bottom;
		this._super(x, y, blocking, level);
		this.setImage(images.objects, 36, 390);
	},
}, 'pipe_right');
var LeftPipe = Ground.extend({
	init: function(x, y, level) {
		var blocking = ground_blocking.left + ground_blocking.bottom;
		this._super(x, y, blocking, level);
		this.setImage(images.objects, 2, 390);
	},
}, 'pipe_left');

/*
 * -------------------------------------------
 * GRASS-SOIL CLASSES
 * -------------------------------------------
 */
var TopRightGrassSoil = Ground.extend({
	init: function(x, y, level) {
		var blocking = ground_blocking.top
		this._super(x, y, blocking, level);
		this.setImage(images.objects, 987, 506);
	},
}, 'grass_top_right_rounded_soil');
var TopLeftGrassSoil = Ground.extend({
	init: function(x, y, level) {
		var blocking = ground_blocking.top
		this._super(x, y, blocking, level);
		this.setImage(images.objects, 955, 506);
	},
}, 'grass_top_left_rounded_soil');






/*
 * -------------------------------------------
 * ANIMATED PLANT CLASS
 * -------------------------------------------
 */
 
var Plant = Base.extend({
	init: function(x, y, blocking, level) {
		this.blocking = blocking;
		this.view = $(DIV).addClass(CLS_PLANT).appendTo(level.world);
		this.level = level;
		this._super(x, y);
		this.setSize(23, 90);
		//this.addToLevel(level);
		this.addToGrid(level);
			
	},
	addToLevel: function(level) {
		level.items.push(this);
	},
	addToGrid: function(level) {
		level.obstacles[this.x / 32][this.level.getGridHeight() - 1 - this.y / 32] = this;
	},
	setImage: function(img, x, y) {
		this.view.css({
			backgroundImage : img ? c2u(img) : 'none',
			backgroundPosition : '-' + (x || 0) + 'px -' + (y || 0) + 'px',
		});
		this._super(img, x, y);
	},
	setPosition: function(x, y) {
		this.view.css({
			left: x,
			bottom: y
		});
		this._super(x, y);
	},
});

/*
 * -------------------------------------------
 * PHOTOSHOP PLANT
 * -------------------------------------------
 */ 
 
 var Photoshop = Plant.extend({
	init: function(x, y, level){
		 this.stars = 4;
	     this._super(x, y, false, level);
		 this.setImage(images.plant, 0,0);  //IMPOSTA L'IMG   
	},

	
	
 },'photoshop');




/*
 * -------------------------------------------
 * DECORATION CLASS
 * -------------------------------------------
 */
var Decoration = Matter.extend({
	init: function(x, y, level) {
		this._super(x, y, ground_blocking.none, level);
		level.decorations.push(this);
	},



	setImage: function(img, x, y) {
		this.view.css({
			backgroundImage : img ? c2u(img) : 'none',
			backgroundPosition : '-' + (x || 0) + 'px -' + (y || 0) + 'px',
		});
		this._super(img, x, y);
	},
	setPosition: function(x, y) {
		this.view.css({
			left: x,
			bottom: y
		});
		this._super(x, y);
	},
});

/*
 * -------------------------------------------
 * DECORATION GRASS CLASSES
 * -------------------------------------------
 */
var TopRightCornerGrass = Decoration.extend({
	init: function(x, y, level) {
		this._super(x, y, level);
		this.setImage(images.objects, 612, 868);
	},
}, 'grass_top_right_corner');
var TopLeftCornerGrass = Decoration.extend({
	init: function(x, y, level) {
		this._super(x, y, level);
		this.setImage(images.objects, 648, 868);
	},
}, 'grass_top_left_corner');

/*
 * -------------------------------------------
 * SOIL CLASSES
 * -------------------------------------------
 */
var Soil = Decoration.extend({
	init: function(x, y, level) {
		this._super(x, y, level);
		this.setImage(images.objects, 888, 438);
	},
}, 'soil');
var RightSoil = Decoration.extend({
	init: function(x, y, level) {
		this._super(x, y, level);
		this.setImage(images.objects, 920, 540);
	},
}, 'soil_right');
var LeftSoil = Decoration.extend({
	init: function(x, y, level) {
		this._super(x, y, level);
		this.setImage(images.objects, 854,540);
	},
}, 'soil_left');

/*
 * -------------------------------------------
 * BUSH CLASSES
 * -------------------------------------------
 */
var RightBush = Decoration.extend({
	init: function(x, y, level) {
		this._super(x, y, level);
		this.setImage(images.objects, 382, 928);
	},
}, 'bush_right');
var RightMiddleBush = Decoration.extend({
	init: function(x, y, level) {
		this._super(x, y, level);
		this.setImage(images.objects, 314, 928);
	},
}, 'bush_middle_right');
var MiddleBush = Decoration.extend({
	init: function(x, y, level) {
		this._super(x, y, level);
		this.setImage(images.objects, 348, 928);
	},
}, 'bush_middle');
var LeftMiddleBush = Decoration.extend({
	init: function(x, y, level) {
		this._super(x, y, level);
		this.setImage(images.objects, 212, 928);
	},
}, 'bush_middle_left');
var LeftBush = Decoration.extend({
	init: function(x, y, level) {
		this._super(x, y, level);
		this.setImage(images.objects, 178, 928);
	},
}, 'bush_left');



/*
 * -------------------------------------------
 * PLANTED SOIL CLASSES
 * -------------------------------------------
 */
var RightPlantedSoil = Decoration.extend({
	init: function(x, y, level) {
		this._super(x, y, level);
		this.setImage(images.objects, 778, 832);
	},
}, 'planted_soil_right');
var MiddlePlantedSoil = Decoration.extend({
	init: function(x, y, level) {
		this._super(x, y, level);
		this.setImage(images.objects, 746, 832);
	},
}, 'planted_soil_middle');
var LeftPlantedSoil = Decoration.extend({
	init: function(x, y, level) {
		this._super(x, y, level);
		this.setImage(images.objects, 714, 832);
	},
}, 'planted_soil_left');

/*
 * -------------------------------------------
 * PIPE DECORATION
 * -------------------------------------------
 */
var RightPipeGrass = Decoration.extend({
	init: function(x, y, level) {
		this._super(x, y, level);
		this.setImage(images.objects, 36, 424);
	},
}, 'pipe_right_grass');
var LeftPipeGrass = Decoration.extend({
	init: function(x, y, level) {
		this._super(x, y, level);
		this.setImage(images.objects, 2, 424);
	},
}, 'pipe_left_grass');
var RightPipeSoil = Decoration.extend({
	init: function(x, y, level) {
		this._super(x, y, level);
		this.setImage(images.objects, 36, 458);
	},
}, 'pipe_right_soil');
var LeftPipeSoil = Decoration.extend({
	init: function(x, y, level) {
		this._super(x, y, level);
		this.setImage(images.objects, 2, 458);
	},
}, 'pipe_left_soil');

/*
 * -------------------------------------------
 * ITEM CLASS
 * -------------------------------------------
 */
var Item = Matter.extend({
	init: function(x, y, isBlocking, level) {
		this.isBouncing = false;
		this.bounceCount = 0;
		this.bounceFrames = Math.floor(50 / constants.interval);
		this.bounceStep = Math.ceil(10 / this.bounceFrames);
		this.bounceDir = 1;
		this.isBlocking = isBlocking;
		this._super(x, y, isBlocking ? ground_blocking.all : ground_blocking.none, level);
		this.activated = false;
		this.addToLevel(level);
	},
	addToLevel: function(level) {
		level.items.push(this);
	},
	activate: function(from) {
		this.activated = true;
	},
	bounce: function() {
		this.isBouncing = true;
		
		for(var i = this.level.figures.length; i--; ) {
			var fig = this.level.figures[i];
			
			if(fig.y === this.y + 32 && fig.x >= this.x - 16 && fig.x <= this.x + 16) {
				if(fig instanceof ItemFigure)
					fig.setVelocity(fig.vx, constants.bounce);
				else
					fig.die();
			}
		}
	},
	playFrame: function() {
		if(this.isBouncing) {
			this.view.css({ 'bottom' : (this.bounceDir > 0 ? '+' : '-') + '=' + this.bounceStep + 'px' });
			this.bounceCount += this.bounceDir;
			
			if(this.bounceCount === this.bounceFrames)
				this.bounceDir = -1;
			else if(this.bounceCount === 0) {
				this.bounceDir = 1;
				this.isBouncing = false;
			}
		}
		
		this._super();
	},
});

/*
 * -------------------------------------------
 * INFO BOX CLOUD CLASS
 * -------------------------------------------
 */
 var InfoBox = Base.extend({
	init: function(x, y, blocking, level) {
		this.blocking = blocking;
		this.view = $(DIV).addClass(CLS_CLOUD).appendTo(level.world);
		this.level = level;
		this._super(x, y);
		this.setSize(160, 96);
		this.addToLevel(level);
		this.addToGrid(level);
		
		//console.log(this.view);
		
	},
	addToLevel: function(level) {
		level.items.push(this);
	},
	addToGrid: function(level) {
		level.obstacles[this.x / 32][this.level.getGridHeight() - 1 - this.y / 32] = this;
	},
	setImage: function(img, x, y) {
		this.view.css({
			backgroundImage : img ? c2u(img) : 'none',
			backgroundPosition : '-' + (x || 0) + 'px -' + (y || 0) + 'px',
		});
		this._super(img, x, y);
	},
	setPosition: function(x, y) {
		this.view.css({
			left: x,
			bottom: y
		});
		this._super(x, y);
	},
});
 
/*
 * -------------------------------------------
 * INFO BOX CLOUD NUMERO 1
 * -------------------------------------------
 */ 
 
 var Cloud1 = InfoBox.extend({
	init: function(x, y, level){
	     this._super(x, y, false, level);
		 this.setImage(images.info, 0,0);  //IMPOSTA L'IMG 
		 level.clickItems.push(this);
		 this.setupFrames( 2.5 , 4, true);      //fps and frames
	// playFrame:
	},
	input: function() {
		  console.log('you clicked me man');
		  open("https://www.comart-design.com/", "parent",);      
           
		
	},
 },'cloudcomart');

/*
 * -------------------------------------------
 * INFO BOX CLOUD NUMERO 2
 * -------------------------------------------
 */ 
 
 var Cloud2 = InfoBox.extend({
	init: function(x, y, level){
	     this._super(x, y, false, level);
		 this.setImage(images.info, 0,0);  //IMPOSTA L'IMG 
		 level.clickItems.push(this);
		 this.setupFrames( 2.5 , 4, true);      //fps and frames
	// playFrame:
	},
	input: function() {
		  console.log('you clicked me man');
		  open("http://www.webseed.it/", "parent",);      
           
		
	},
 },'cloudseed');


/*
 * -------------------------------------------
 * INFO BOX CLOUD NUMERO 3
 * -------------------------------------------
 */ 
 
 var Cloud3 = InfoBox.extend({
	init: function(x, y, level){
	     this._super(x, y, false, level);
		 this.setImage(images.info, 0,0);  //IMPOSTA L'IMG 
		 level.clickItems.push(this);
		 this.setupFrames( 2.5 , 4, true);      //fps and frames
	// playFrame:
	},
	input: function() {
		  console.log('you clicked me man');
		  open("www.youtube.com", "parent",);      
           
		
	},
 },'cloudmusic');


/*
 * -------------------------------------------
 * INFO BOX CLOUD NUMERO 4
 * -------------------------------------------
 */ 
 
 var Cloud4 = InfoBox.extend({
	init: function(x, y, level){
	     this._super(x, y, false, level);
		 this.setImage(images.info, 0,0);  //IMPOSTA L'IMG 
		 level.clickItems.push(this);
		 this.setupFrames( 2.5 , 4, true);      //fps and frames
	// playFrame:
	},
	input: function() {
		  console.log('you clicked me man');
		  open("http://www.mercurywood.com/", "parent",);      
           
		
	},
 },'cloudmercury');

/*
 * -------------------------------------------
 * INFO BOX CLOUD NUMERO 5
 * -------------------------------------------
 */ 
 
 var Cloud5 = InfoBox.extend({
	init: function(x, y, level){
	     this._super(x, y, false, level);
		 this.setImage(images.info, 0,0);  //IMPOSTA L'IMG 
		 level.clickItems.push(this);
		 this.setupFrames( 2.5 , 4, true);      //fps and frames
	// playFrame:
	},
	input: function() {
		  console.log('you clicked me man');
		  open("http://www.lsi.edu/en/schools/canada/learn-english-in-toronto", "parent",);      
           
		
	},
 },'cloudlsi');

/*
 * -------------------------------------------
 * INFO BOX CLOUD NUMERO 6
 * -------------------------------------------
 */ 
 
 var Cloud6 = InfoBox.extend({
	init: function(x, y, level){
	     this._super(x, y, false, level);
		 this.setImage(images.info, 0,0);  //IMPOSTA L'IMG 
		 level.clickItems.push(this);
		 this.setupFrames( 2.5 , 4, true);      //fps and frames
	// playFrame:
	},
	input: function() {
		  console.log('you clicked me man');
		  open("https://www.supdepub.com/", "parent",);      
           
		
	},
 },'cloudsdp');


/*
 * -------------------------------------------
 * COIN CLASSES
 * -------------------------------------------
 */
var Coin = Item.extend({
	init: function(x, y, level) {
		this._super(x, y, false, level);
		this.setImage(images.objects, 0, 0);  //IMPOSTA L'IMG DEL COIN
		this.setupFrames(10, 4, true);      //ANIMAZIONE ROTAZIONE DEI COIN: SPEED AND FRAMES
	},
	activate: function(from) {
		if(!this.activated) {
			this.level.playSound('coin');
			
			from.addCoin();                 //AGGIORNA IL TOTALE DEI COINS
			this.remove();                 //RIMUOVE IL COIN DALLO SCHERMO
			}
		this._super(from);                 //RESETTA L'AREA DI GIOCO DOVE C'ERA IL COIN (ACTIVATED = FALSE)
		
	},
	remove: function() {
		this.view.remove();
    },	
  }, 'coin');
var CoinBoxCoin = Coin.extend({
	init: function(x, y, level) {
		this._super(x, y, level);
		this.setImage(images.objects, 96, 0);
		this.clearFrames();
		this.view.hide();
		this.count = 0;
		this.frames = Math.floor(150 / constants.interval);
		this.step = Math.ceil(30 / this.frames);
	},
	remove: function() { },
	addToGrid: function() { },
	addToLevel: function() { },
	activate: function(from) {
		this._super(from);
		this.view.show().css({ 'bottom' : '+=8px' });
	},
	act: function() {
		this.view.css({ 'bottom' : '+=' + this.step + 'px' });
		this.count++;
		return (this.count === this.frames);
	},
});
var CoinBox = Item.extend({
	init: function(x, y, level, amount) {
		this._super(x, y, true, level);
		this.setImage(images.objects, 345, 328);
		this.setAmount(amount || 2);      //NUMERO DI COIN NEL BOX ALTRIMENTI NUMERO DI DEFAULT
	},
	setAmount: function(amount) {
		this.items = [];
		this.actors = [];
		
		for(var i = 0; i < amount; i++)
			this.items.push(new CoinBoxCoin(this.x, this.y, this.level));
	},
	activate: function(from) {
		if(!this.isBouncing) {
			if(this.items.length) {
				this.bounce();
				var coin = this.items.pop();
				coin.activate(from);                                 //RICHIAMA METODO ACTIVATE DELLA CLASSE COIN
				this.actors.push(coin);
				if(!this.items.length)  {                      //RESETTA L'IMMAGINE DEL BOX SE IL NUMERO DI COIN è TERMINATO
					this.setImage(images.objects, 512, 194);
			}}
		}
			
		this._super(from);
	},
	playFrame: function() {
		for(var i = this.actors.length; i--; ) {
			if(this.actors[i].act()) {
				this.actors[i].view.remove();
				this.actors.splice(i, 1);
			}
		}
		
		this._super();
	},
}, 'coinbox');
var MultipleCoinBox = CoinBox.extend({
	init: function(x, y, level) {
		this._super(x, y, level, 8);
	},
}, 'multiple_coinbox');

/*
 * -------------------------------------------
 * ITEMFIGURE CLASS
 * -------------------------------------------
 */
var ItemFigure = Figure.extend({
	init: function(x, y, level) {
		this._super(x, y, level);
	},
});

/*
 * -------------------------------------------
 * STARBOX CLASS
 * -------------------------------------------
 */
var StarBox = Item.extend({
	init: function(x, y, level) {
		this._super(x, y, true, level);
		this.setImage(images.objects, 96, 33);
		this.star = new Star(x, y, level);
		this.setupFrames(8, 4, false);
	},
	activate: function(from) {
		if(!this.activated) {
			this.star.release();
			this.clearFrames();
			this.bounce();
			this.setImage(images.objects, 512, 194);
		}
		
		this._super(from);
	},
}, 'starbox');
var Star = ItemFigure.extend({
	init: function(x, y, level) {
		this._super(x, y + 32, level);
		this.active = false;
		this.setSize(32, 32);
		this.setImage(images.objects, 32, 69);
		this.view.hide();
	},
	release: function() {
		this.taken = 4;
		this.active = true;
		this.level.playSound('mushroom');
		this.view.show();
		this.setVelocity(constants.star_vx, constants.star_vy);
		this.setupFrames(10, 2, false);
	},
	collides: function(is, ie, js, je, blocking) {
		return false;
	},
	move: function() {
		if(this.active) {
			this.vy += this.vy <= -constants.star_vy ? constants.gravity : constants.gravity / 2;
			this._super();
		}
		
		if(this.taken)
			this.taken--;
	},
	hit: function(opponent) {
		if(!this.taken && this.active && opponent instanceof Mario) {
			opponent.invincible();
			this.die();
		}
	},
});

/*
 * -------------------------------------------
 * MUSHROOMBOX CLASS
 * -------------------------------------------
 */
var MushroomBox = Item.extend({
	init: function(x, y, level) {
		this._super(x, y, true, level);
		this.setImage(images.objects, 96, 33);
		this.max_mode = mushroom_mode.plant;
		this.mushroom = new Mushroom(x, y, level);
		this.setupFrames(8, 4, false);
	},
	activate: function(from) {
		if(!this.activated) {
			if(from.state === size_states.small || this.max_mode === mushroom_mode.mushroom)
				this.mushroom.release(mushroom_mode.mushroom);
			else
				this.mushroom.release(mushroom_mode.plant);
			
			this.clearFrames();
			this.bounce();
			this.setImage(images.objects, 512, 194);
		}
			
		this._super(from);
	},
}, 'mushroombox');
var Mushroom = ItemFigure.extend({
	init: function(x, y, level) {
		this._super(x, y, level);
		this.active = false;
		this.setSize(32, 32);
		this.setImage(images.objects, 582, 60);
		this.released = 0;
		this.view.css('z-index', 94).hide();
	},
	release: function(mode) {
		this.released = 4;
		this.level.playSound('mushroom');
		
		if(mode === mushroom_mode.plant)
			this.setImage(images.objects, 548, 60);
			
		this.mode = mode;
		this.view.show();
	},
	move: function() {
		if(this.active) {
			this._super();
		
			if(this.mode === mushroom_mode.mushroom && this.vx === 0)
				this.setVelocity(this.direction === directions.right ? -constants.mushroom_v : constants.mushroom_v, this.vy);
		} else if(this.released) {
			this.released--;
			this.setPosition(this.x, this.y + 8);
			
			if(!this.released) {
				this.active = true;
				this.view.css('z-index', 99);
				
				if(this.mode === mushroom_mode.mushroom)
					this.setVelocity(constants.mushroom_v, constants.gravity);
			}
		}
	},
	hit: function(opponent) {
		if(this.active && opponent instanceof Mario) {
			if(this.mode === mushroom_mode.mushroom)
				opponent.grow();
			else if(this.mode === mushroom_mode.plant)
				opponent.shooter();
				
			this.die();
		}
	},
});



/*
 * -------------------------------------------
 * HERO CLASS
 * -------------------------------------------
 */
var Hero = Figure.extend({       		//HERO ESTENDE FIGURE
	init: function(x, y, level) {       //COSTRUTTORE CON X Y AND LEVEL
		this._super(x, y, level);       //COSTRUTTORE PADRE OVVERO FIGURE
	},
});

/*
 * -------------------------------------------
 * MARIO CLASS
 * -------------------------------------------
 */
var Mario = Hero.extend({
	init: function(x, y, level) {
		this.standSprites = [
			[[{ x : 0, y : 81},{ x: 481, y : 83}],[{ x : 81, y : 0},{ x: 561, y : 83}]],
			[[{ x : 0, y : 162},{ x: 481, y : 247}],[{ x : 81, y : 243},{ x: 561, y : 247}]]
		];
		this.crouchSprites = [
			[{ x : 241, y : 0},{ x: 161, y : 0}],
			[{ x : 241, y : 162},{ x: 241, y : 243}]
		];
		this.deadly = 0;
		this.invulnerable = 0;
		this.width = 80;
		this._super(x, y, level);
		this.blinking = 0;
		this.setOffset(-24, 0);
		this.setSize(80, 80);
		this.cooldown = 0;
		this.setMarioState(mario_states.normal);
		this.setLifes(constants.start_lives);
		this.setCoins(0);
		this.deathBeginWait = Math.floor(700 / constants.interval);
		this.deathEndWait = 0;
		this.deathFrames = Math.floor(600 / constants.interval);
		this.deathStepUp = Math.ceil(200 / this.deathFrames);
		this.deathDir = 1;
		this.deathCount = 0;
		this.direction = directions.right;
		this.setImage(images.sprites, 81, 0);
		this.crouching = false;
		this.fast = false;
	},
	setMarioState: function(state) {
		this.marioState = state;
		//this.state = size_states.big;
	},
	setState: function(state) {
		if(state !== this.state) {
			this.setMarioState(mario_states.normal);
			this._super(state);
		}
	},
	setPosition: function(x, y) {
		this._super(x, y);
		var r = this.level.width - 640;
		var w = (this.x <= 210) ? 0 : ((this.x >= this.level.width - 230) ? r : r / (this.level.width - 440) * (this.x - 210));		
		this.level.setParallax(w);

		if(this.onground && this.x >= this.level.width - 128)
			this.victory();
	},
	input: function(keys) {
		this.fast = keys.accelerate;
		this.crouching = keys.down;
		
		if(!this.crouching) {
			if(this.onground && keys.up)
				this.jump();
				
			if(keys.accelerate && this.marioState === mario_states.fire)
				this.shoot();
				
			if(keys.right || keys.left)
				this.walk(keys.left, keys.accelerate);
			else
				this.vx = 0;
		}
	},
	victory: function() {
		this.level.playMusic('success');
		this.clearFrames();
		this.view.show();
		this.setImage(images.sprites, this.state === size_states.small ? 241 : 161, 81);
		this.level.next();
	},
	shoot: function() {
		if(!this.cooldown) {
			this.cooldown = constants.cooldown;
			this.level.playSound('shoot');
			new Bullet(this);
		}
	},
	setVelocity: function(vx, vy) {
		if(this.crouching) {
			vx = 0;
			this.crouch();
		} else {
			if(this.onground && vx > 0)
				this.walkRight();
			else if(this.onground && vx < 0)
				this.walkLeft();
			else
				this.stand();
		}
	
		this._super(vx, vy);
	},
	blink: function(times) {
		this.blinking = Math.max(2 * times * constants.blinkfactor, this.blinking || 0);
	},
	invincible: function() {
		this.level.playMusic('invincibility');
		this.deadly = Math.floor(constants.invincible / constants.interval);
		this.invulnerable = this.deadly;
		this.blink(Math.ceil(this.deadly / (2 * constants.blinkfactor)));
	},
	grow: function() {
		if(this.state === size_states.small) {
			this.level.playSound('grow');
			this.setState(size_states.big);
			this.blink(3);
		}
	},
	shooter: function() {
		if(this.state === size_states.small)
			this.grow();
		else
			this.level.playSound('grow');
			
		this.setMarioState(mario_states.fire);
	},
	walk: function(reverse, fast) {
		this.vx = constants.walking_v * (fast ? 2 : 1) * (reverse ? - 1 : 1);
	},
	walkRight: function() {
		if(this.state === size_states.small) {
			if(!this.setupFrames(8, 2, true, 'WalkRightSmall'))
				this.setImage(images.sprites, 0, 0);
		} else {
			if(!this.setupFrames(9, 2, true, 'WalkRightBig'))
				this.setImage(images.sprites, 0, 243);
		}
	},
	walkLeft: function() {
		if(this.state === size_states.small) {
			if(!this.setupFrames(8, 2, false, 'WalkLeftSmall'))
				this.setImage(images.sprites, 80, 81);
		} else {
			if(!this.setupFrames(9, 2, false, 'WalkLeftBig'))
				this.setImage(images.sprites, 81, 162);
		}
	},
	stand: function() {
		var coords = this.standSprites[this.state - 1][this.direction === directions.left ? 0 : 1][this.onground ? 0 : 1];
		this.setImage(images.sprites, coords.x, coords.y);
		this.clearFrames();
	},
	crouch: function() {
		var coords = this.crouchSprites[this.state - 1][this.direction === directions.left ? 0 : 1];
		this.setImage(images.sprites, coords.x, coords.y);
		this.clearFrames();
	},
	jump: function() {
		this.level.playSound('jump');
		this.vy = constants.jumping_v;
	},
	move: function() {
		this.input(keys);		
		this._super();
	},
	addCoin: function() {
		this.setCoins(this.coins + 1);
	},
	playFrame: function() {		
		if(this.blinking) {
			if(this.blinking % constants.blinkfactor === 0)
				this.view.toggle();
				
			this.blinking--;
		}
		
		if(this.cooldown)
			this.cooldown--;
		
		if(this.deadly)
			this.deadly--;
		
		if(this.invulnerable)
			this.invulnerable--;
		
		this._super();
	},
	setCoins: function(coins) {
		this.coins = coins;
		
		if(this.coins >= constants.max_coins) {
			this.addLife()
			this.coins -= constants.max_coins;
		}
				
		this.level.world.parent().children('#coinNumber').text(this.coins);
	},
	addLife: function() {
		this.level.playSound('liveupgrade');
		this.setLifes(this.lifes + 1);
	},
	setLifes : function(lifes) {
		this.lifes = lifes;
		this.level.world.parent().children('#liveNumber').text(this.lifes);
	},
	death: function() {
		if(this.deathBeginWait) {
			this.deathBeginWait--;
			return true;
		}
		
		if(this.deathEndWait)
			return --this.deathEndWait;
		
		this.view.css({ 'bottom' : (this.deathDir > 0 ? '+' : '-') + '=' + (this.deathDir > 0 ? this.deathStepUp : this.deathStepDown) + 'px' });
		this.deathCount += this.deathDir;
		
		if(this.deathCount === this.deathFrames)
			this.deathDir = -1;
		else if(this.deathCount === 0)
			this.deathEndWait = Math.floor(1800 / constants.interval);
			
		return true;
	},
	die: function() {
		this.setMarioState(mario_states.normal);
		this.deathStepDown = Math.ceil(240 / this.deathFrames);
		this.setupFrames(9, 2, false);
		this.setImage(images.sprites, 81, 324);
		this.level.playMusic('die');
		this._super();
	},
	hurt: function(from) {
		if(this.deadly)
			from.die();
		else if(this.invulnerable)
			return;
		else if(this.state === size_states.small) {
			this.die();
		} else {
			this.invulnerable = Math.floor(constants.invulnerable / constants.interval);
			this.blink(Math.ceil(this.invulnerable / (2 * constants.blinkfactor)));
			this.setState(size_states.small);
			this.level.playSound('hurt');			
		}
	},
}, 'mario');

/*
 * -------------------------------------------
 * DOCUMENT READY STARTUP METHOD
 * -------------------------------------------
 */
$(document).ready(function() {
	
	var level = new Level('world');
	level.load(definedLevels[0]);
	level.start();
	keys.bind();
	mouse.bind(level);
});